<script lang="ts">
    import { metatags } from '@roxi/routify'
    import { BrowserType, IWalletRequestElements, Utils } from '../../classes/utils';
    import { onMount } from 'svelte';
    import axios from 'axios';
    import { PublicKey } from '../../classes/storage/public-key';
    import { Toast } from '../../classes/toast';
    import { notifFailure, notifSuccess } from '../../stores/notification';

    metatags.title = 'Send SXP to user'
    metatags.description = 'Description coming soon...'

    let userId: string = null;
    let amount: number = null;
    let loading: boolean = false;

    let exampleUrlSendAny: string;
    $: exampleUrlSendAny = location.href + '/' + myUserId;
    let exampleUrlSendAmount: string;
    $: exampleUrlSendAmount = location.href + '/' + myUserId + '/50.30';
    let myUserId: string = '<id>';

    const isWebview: boolean = Utils.getBrowserType() === BrowserType.WebView;

    onMount(() => {
        let pk: string = PublicKey.get() || '';
        if (pk) {
            Utils.getWalletRequestElements()
                .then((elements: IWalletRequestElements) => axios.post('/api/user', {pk: elements.pk, qs: elements.qs, signature: elements.signature}))
                .then(xhr => {
                    myUserId = xhr.data;
                });
        }
    });

    function sendMoney(): void {
        loading = true;
        Utils.sendMoney(userId.toUpperCase(), amount)
            .then(() => {
                Toast.success('Successful withdrawal');
            })
            .catch(err => {
                if (err?.response?.data) {
                    Toast.failure(err.response.data);
                } else {
                    Toast.failure(err);
                }
            })
            .finally(() => {
                loading = false;
            })
    }

    function copyTransferPage() {
        if (Utils.copyToClipboard(exampleUrlSendAny)) {
            notifSuccess.set('Link successfully copied to your clipboard');
        } else {
            notifFailure.set('Cannot copy the link to your clipboard');
        }
    }
</script>

<style lang="scss">
    .margin-top {
        margin-top: 2em;
    }

    .user-input {
        text-transform: uppercase;
    }
</style>
<div class="is-justify-content-center is-flex">
    <form on:submit|preventDefault={() => sendMoney()} class="row">
        <div class="card">
            <div class="card-header">
                <div class="card-header-title">
                    Send SXP to
                </div>
            </div>
            <div class="card-content">
                <div class="field">
                    <p class="control">
                        <input class="input user-input" type="text" placeholder="User ID (i.e. RF5T)" bind:value={userId}>
                    </p>
                </div>
                <div class="field has-addons">
                    <p class="control">
                        <input class="input" type="number" step="0.01" placeholder="Amount (i.e. 20)" bind:value="{amount}">
                        <small>Fees may apply, consult <a target="_blank" href="https://www.binance.com/en/fee/depositFee">withdrawal fees table</a></small>
                    </p>
                    <p class="control">
                        <a href="." class="button is-static">SXP</a>
                    </p>
                </div>

                <div class="is-justify-content-center is-flex">
                    <button class="button is-primary" class:is-loading={loading}>Send</button>
                </div>
            </div>
        </div>
    </form>
</div>
<div class="has-text-centered margin-top">
    {#if isWebview}
        <p>If you want your friends or clients to send money to you, you can send them the link to your custom SXP/Me page:</p>
        <button on:click={copyTransferPage}>Copy link</button>
    {:else}
    <p>If you want your friends or clients to send money to you, you can copy paste to them:</p>
    <ul>
        <li><a href={exampleUrlSendAny}>{exampleUrlSendAny}</a></li>
        <li><a href={exampleUrlSendAmount}>{exampleUrlSendAmount}</a> and modify the amount to send in the link</li>
    </ul>
    {/if}
</div>
